# Stubs for docutils.writers.manpage (Python 3.6)
#
# NOTE: This dynamically typed stub was automatically generated by stubgen.

from docutils import nodes, SettingsSpec, writers
from types import ModuleType
from typing import Any, Callable, Dict, List, Optional, Pattern, Tuple, Type

__docformat__: str
FIELD_LIST_INDENT: int
DEFINITION_LIST_INDENT: int
OPTION_LIST_INDENT: int
BLOCKQOUTE_INDENT: float
LITERAL_BLOCK_INDENT: float
MACRO_DEF: str

class Writer(writers.Writer):
    supported: Tuple[str, ...] = ...
    output: Any = ...
    translator_class: Type[Translator] = ...
    def __init__(self) -> None: ...
    def translate(self) -> None: ...

class Table:
    def __init__(self) -> None: ...
    def new_row(self) -> None: ...
    def append_separator(self, separator: str) -> None: ...
    def append_cell(self, cell_lines: List[str]) -> None: ...
    def as_list(self) -> List[str]: ...

class Translator(nodes.NodeVisitor):
    words_and_spaces: Pattern[str] = ...
    possibly_a_roff_command: Pattern[str] = ...
    document_start: str = ...
    settings: SettingsSpec = ...
    language: ModuleType = ...
    head: List[str] = ...
    body: List[str] = ...
    foot: List[str] = ...
    section_level: int = ...
    context: List[Any] = ...
    topic_class: str = ...
    colspecs: List[nodes.Node] = ...
    compact_p: int = ...
    compact_simple: Any = ...
    header_written: int = ...
    authors: List[Any] = ...
    defs: Dict[str, Tuple[str, str]] = ...
    def __init__(self, document: nodes.document) -> None: ...
    def comment_begin(self, text: str) -> str: ...
    def comment(self, text: str) -> str: ...
    def ensure_eol(self) -> None: ...
    def astext(self) -> str: ...
    def deunicode(self, text: str) -> str: ...
    def visit_Text(self, node: nodes.Node) -> None: ...
    def depart_Text(self, node: nodes.Node) -> None: ...
    def list_start(self, node: nodes.Node) -> None: ...
    def list_end(self) -> None: ...
    def header(self) -> str: ...
    def append_header(self) -> None: ...
    def visit_address(self, node: nodes.Node) -> None: ...
    def depart_address(self, node: nodes.Node) -> None: ...
    def visit_admonition(self, node: nodes.Node, name: Optional[str] = ...) -> None: ...
    def depart_admonition(self, node: nodes.Node) -> None: ...
    def visit_attention(self, node: nodes.Node) -> None: ...
    depart_attention: Callable[[nodes.Node], None] = ...
    def visit_docinfo_item(self, node: nodes.Node, name: str) -> None: ...
    def depart_docinfo_item(self, node: nodes.Node) -> None: ...
    def visit_author(self, node: nodes.Node) -> None: ...
    depart_author: Callable[[nodes.Node], None] = ...
    def visit_authors(self, node: nodes.Node) -> None: ...
    def depart_authors(self, node: nodes.Node) -> None: ...
    def visit_block_quote(self, node: nodes.Node) -> None: ...
    def depart_block_quote(self, node: nodes.Node) -> None: ...
    def visit_bullet_list(self, node: nodes.Node) -> None: ...
    def depart_bullet_list(self, node: nodes.Node) -> None: ...
    def visit_caption(self, node: nodes.Node) -> None: ...
    def depart_caption(self, node: nodes.Node) -> None: ...
    def visit_caution(self, node: nodes.Node) -> None: ...
    depart_caution: Callable[[nodes.Node], None] = ...
    def visit_citation(self, node: nodes.Node) -> None: ...
    def depart_citation(self, node: nodes.Node) -> None: ...
    def visit_citation_reference(self, node: nodes.Node) -> None: ...
    def visit_classifier(self, node: nodes.Node) -> None: ...
    def depart_classifier(self, node: nodes.Node) -> None: ...
    def visit_colspec(self, node: nodes.Node) -> None: ...
    def depart_colspec(self, node: nodes.Node) -> None: ...
    def write_colspecs(self) -> None: ...
    def visit_comment(self, node: nodes.Node, sub: Callable[[str, str], str] = ...) -> None: ...
    def visit_contact(self, node: nodes.Node) -> None: ...
    depart_contact: Callable[[nodes.Node], None] = ...
    def visit_container(self, node: nodes.Node) -> None: ...
    def depart_container(self, node: nodes.Node) -> None: ...
    def visit_compound(self, node: nodes.Node) -> None: ...
    def depart_compound(self, node: nodes.Node) -> None: ...
    def visit_copyright(self, node: nodes.Node) -> None: ...
    def visit_danger(self, node: nodes.Node) -> None: ...
    depart_danger: Callable[[nodes.Node], None] = ...
    def visit_date(self, node: nodes.Node) -> None: ...
    def visit_decoration(self, node: nodes.Node) -> None: ...
    def depart_decoration(self, node: nodes.Node) -> None: ...
    def visit_definition(self, node: nodes.Node) -> None: ...
    def depart_definition(self, node: nodes.Node) -> None: ...
    def visit_definition_list(self, node: nodes.Node) -> None: ...
    def depart_definition_list(self, node: nodes.Node) -> None: ...
    def visit_definition_list_item(self, node: nodes.Node) -> None: ...
    def depart_definition_list_item(self, node: nodes.Node) -> None: ...
    def visit_description(self, node: nodes.Node) -> None: ...
    def depart_description(self, node: nodes.Node) -> None: ...
    def visit_docinfo(self, node: nodes.Node) -> None: ...
    def depart_docinfo(self, node: nodes.Node) -> None: ...
    def visit_doctest_block(self, node: nodes.Node) -> None: ...
    def depart_doctest_block(self, node: nodes.Node) -> None: ...
    def visit_document(self, node: nodes.Node) -> None: ...
    def depart_document(self, node: nodes.Node) -> None: ...
    def visit_emphasis(self, node: nodes.Node) -> None: ...
    def depart_emphasis(self, node: nodes.Node) -> None: ...
    def visit_entry(self, node: nodes.Node) -> None: ...
    def depart_entry(self, node: nodes.Node) -> None: ...
    def visit_enumerated_list(self, node: nodes.Node) -> None: ...
    def depart_enumerated_list(self, node: nodes.Node) -> None: ...
    def visit_error(self, node: nodes.Node) -> None: ...
    depart_error: Callable[[nodes.Node], None] = ...
    def visit_field(self, node: nodes.Node) -> None: ...
    def depart_field(self, node: nodes.Node) -> None: ...
    def visit_field_body(self, node: nodes.Node) -> None: ...
    def depart_field_body(self, node: nodes.Node) -> None: ...
    def visit_field_list(self, node: nodes.Node) -> None: ...
    def depart_field_list(self, node: nodes.Node) -> None: ...
    def visit_field_name(self, node: nodes.Node) -> None: ...
    def depart_field_name(self, node: nodes.Node) -> None: ...
    def visit_figure(self, node: nodes.Node) -> None: ...
    def depart_figure(self, node: nodes.Node) -> None: ...
    def visit_footer(self, node: nodes.Node) -> None: ...
    def depart_footer(self, node: nodes.Node) -> None: ...
    def visit_footnote(self, node: nodes.Node) -> None: ...
    def depart_footnote(self, node: nodes.Node) -> None: ...
    def footnote_backrefs(self, node: nodes.Node) -> None: ...
    def visit_footnote_reference(self, node: nodes.Node) -> None: ...
    def depart_footnote_reference(self, node: nodes.Node) -> None: ...
    def visit_generated(self, node: nodes.Node) -> None: ...
    def depart_generated(self, node: nodes.Node) -> None: ...
    def visit_header(self, node: nodes.Node) -> None: ...
    def depart_header(self, node: nodes.Node) -> None: ...
    def visit_hint(self, node: nodes.Node) -> None: ...
    depart_hint: Callable[[nodes.Node], None] = ...
    def visit_subscript(self, node: nodes.Node) -> None: ...
    def depart_subscript(self, node: nodes.Node) -> None: ...
    def visit_superscript(self, node: nodes.Node) -> None: ...
    def depart_superscript(self, node: nodes.Node) -> None: ...
    def visit_attribution(self, node: nodes.Node) -> None: ...
    def depart_attribution(self, node: nodes.Node) -> None: ...
    def visit_image(self, node: nodes.Node) -> None: ...
    def visit_important(self, node: nodes.Node) -> None: ...
    depart_important: Callable[[nodes.Node], None] = ...
    def visit_inline(self, node: nodes.Node) -> None: ...
    def depart_inline(self, node: nodes.Node) -> None: ...
    def visit_label(self, node: nodes.Node) -> None: ...
    def depart_label(self, node: nodes.Node) -> None: ...
    def visit_legend(self, node: nodes.Node) -> None: ...
    def depart_legend(self, node: nodes.Node) -> None: ...
    def visit_line_block(self, node: nodes.Node) -> None: ...
    def depart_line_block(self, node: nodes.Node) -> None: ...
    def visit_line(self, node: nodes.Node) -> None: ...
    def depart_line(self, node: nodes.Node) -> None: ...
    def visit_list_item(self, node: nodes.Node) -> None: ...
    def depart_list_item(self, node: nodes.Node) -> None: ...
    def visit_literal(self, node: nodes.Node) -> None: ...
    def depart_literal(self, node: nodes.Node) -> None: ...
    def visit_literal_block(self, node: nodes.Node) -> None: ...
    def depart_literal_block(self, node: nodes.Node) -> None: ...
    def visit_math(self, node: nodes.Node) -> None: ...
    def depart_math(self, node: nodes.Node) -> None: ...
    def visit_math_block(self, node: nodes.Node) -> None: ...
    def depart_math_block(self, node: nodes.Node) -> None: ...
    def visit_meta(self, node: nodes.Node) -> None: ...
    def depart_meta(self, node: nodes.Node) -> None: ...
    def visit_note(self, node: nodes.Node) -> None: ...
    depart_note: Callable[[nodes.Node], None] = ...
    def indent(self, by: float = ...) -> None: ...
    def dedent(self) -> None: ...
    def visit_option_list(self, node: nodes.Node) -> None: ...
    def depart_option_list(self, node: nodes.Node) -> None: ...
    def visit_option_list_item(self, node: nodes.Node) -> None: ...
    def depart_option_list_item(self, node: nodes.Node) -> None: ...
    def visit_option_group(self, node: nodes.Node) -> None: ...
    def depart_option_group(self, node: nodes.Node) -> None: ...
    def visit_option(self, node: nodes.Node) -> None: ...
    def depart_option(self, node: nodes.Node) -> None: ...
    def visit_option_string(self, node: nodes.Node) -> None: ...
    def depart_option_string(self, node: nodes.Node) -> None: ...
    def visit_option_argument(self, node: nodes.Node) -> None: ...
    def depart_option_argument(self, node: nodes.Node) -> None: ...
    def visit_organization(self, node: nodes.Node) -> None: ...
    def depart_organization(self, node: nodes.Node) -> None: ...
    def first_child(self, node: nodes.Node) -> int: ...
    def visit_paragraph(self, node: nodes.Node) -> None: ...
    def depart_paragraph(self, node: nodes.Node) -> None: ...
    def visit_problematic(self, node: nodes.Node) -> None: ...
    def depart_problematic(self, node: nodes.Node) -> None: ...
    def visit_raw(self, node: nodes.Node) -> None: ...
    def visit_reference(self, node: nodes.Node) -> None: ...
    def depart_reference(self, node: nodes.Node) -> None: ...
    def visit_revision(self, node: nodes.Node) -> None: ...
    depart_revision: Callable[[nodes.Node], None] = ...
    def visit_row(self, node: nodes.Node) -> None: ...
    def depart_row(self, node: nodes.Node) -> None: ...
    def visit_section(self, node: nodes.Node) -> None: ...
    def depart_section(self, node: nodes.Node) -> None: ...
    def visit_status(self, node: nodes.Node) -> None: ...
    depart_status: Callable[[nodes.Node], None] = ...
    def visit_strong(self, node: nodes.Node) -> None: ...
    def depart_strong(self, node: nodes.Node) -> None: ...
    def visit_substitution_definition(self, node: nodes.Node) -> None: ...
    def visit_substitution_reference(self, node: nodes.Node) -> None: ...
    def visit_subtitle(self, node: nodes.Node) -> None: ...
    def depart_subtitle(self, node: nodes.Node) -> None: ...
    def visit_system_message(self, node: nodes.Node) -> None: ...
    def depart_system_message(self, node: nodes.Node) -> None: ...
    def visit_table(self, node: nodes.Node) -> None: ...
    def depart_table(self, node: nodes.Node) -> None: ...
    def visit_target(self, node: nodes.Node) -> None: ...
    def visit_tbody(self, node: nodes.Node) -> None: ...
    def depart_tbody(self, node: nodes.Node) -> None: ...
    def visit_term(self, node: nodes.Node) -> None: ...
    def depart_term(self, node: nodes.Node) -> None: ...
    def visit_tgroup(self, node: nodes.Node) -> None: ...
    def depart_tgroup(self, node: nodes.Node) -> None: ...
    def visit_thead(self, node: nodes.Node) -> None: ...
    def depart_thead(self, node: nodes.Node) -> None: ...
    def visit_tip(self, node: nodes.Node) -> None: ...
    depart_tip: Callable[[nodes.Node], None] = ...
    def visit_title(self, node: nodes.Node) -> None: ...
    def depart_title(self, node: nodes.Node) -> None: ...
    def visit_title_reference(self, node: nodes.Node) -> None: ...
    def depart_title_reference(self, node: nodes.Node) -> None: ...
    def visit_topic(self, node: nodes.Node) -> None: ...
    def depart_topic(self, node: nodes.Node) -> None: ...
    def visit_sidebar(self, node: nodes.Node) -> None: ...
    def depart_sidebar(self, node: nodes.Node) -> None: ...
    def visit_rubric(self, node: nodes.Node) -> None: ...
    def depart_rubric(self, node: nodes.Node) -> None: ...
    def visit_transition(self, node: nodes.Node) -> None: ...
    def depart_transition(self, node: nodes.Node) -> None: ...
    def visit_version(self, node: nodes.Node) -> None: ...
    def visit_warning(self, node: nodes.Node) -> None: ...
    depart_warning: Callable[[nodes.Node], None] = ...
    def unimplemented_visit(self, node: nodes.Node) -> None: ...
